package dev.shadowsoffire.apotheosis.adventure.compat;

import mezz.jei.api.recipe.category.extensions.IRecipeCategoryExtension;
import java.util.IdentityHashMap;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import net.minecraft.client.gui.GuiGraphics;
import mezz.jei.api.gui.ingredient.IRecipeSlotsView;
import mezz.jei.api.recipe.RecipeType;
import mezz.jei.api.ingredients.IIngredientType;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.Blocks;
import mezz.jei.api.constants.VanillaTypes;
import mezz.jei.api.helpers.IGuiHelper;
import mezz.jei.api.gui.drawable.IDrawable;
import net.minecraft.network.chat.Component;
import java.util.Map;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.crafting.SmithingRecipe;
import mezz.jei.api.recipe.category.IRecipeCategory;

public class ApothSmithingCategory implements IRecipeCategory<SmithingRecipe>
{
    public static final ResourceLocation RECIPE_GUI_VANILLA;
    private static final Map<Class<? extends SmithingRecipe>, Extension<SmithingRecipe>> EXTENSIONS;
    private final Component title;
    private final IDrawable background;
    private final IDrawable icon;
    
    public ApothSmithingCategory(final IGuiHelper guiHelper) {
        this.title = (Component)Component.m_237115_("title.apotheosis.smithing");
        this.background = (IDrawable)guiHelper.drawableBuilder(ApothSmithingCategory.RECIPE_GUI_VANILLA, 0, 168, 125, 18).addPadding(0, 16, 0, 0).build();
        this.icon = guiHelper.createDrawableIngredient((IIngredientType)VanillaTypes.ITEM_STACK, (Object)new ItemStack((ItemLike)Blocks.f_50625_));
    }
    
    public RecipeType<SmithingRecipe> getRecipeType() {
        return AdventureJEIPlugin.APO_SMITHING;
    }
    
    public Component getTitle() {
        return this.title;
    }
    
    public IDrawable getBackground() {
        return this.background;
    }
    
    public IDrawable getIcon() {
        return this.icon;
    }
    
    public void draw(final SmithingRecipe recipe, final IRecipeSlotsView recipeSlotsView, final GuiGraphics gfx, final double mouseX, final double mouseY) {
        ApothSmithingCategory.EXTENSIONS.get(recipe.getClass()).draw(recipe, recipeSlotsView, gfx, mouseX, mouseY);
    }
    
    public void setRecipe(final IRecipeLayoutBuilder builder, final SmithingRecipe recipe, final IFocusGroup focuses) {
        ApothSmithingCategory.EXTENSIONS.get(recipe.getClass()).setRecipe(builder, recipe, focuses);
    }
    
    public boolean isHandled(final SmithingRecipe recipe) {
        return ApothSmithingCategory.EXTENSIONS.containsKey(recipe.getClass());
    }
    
    public static <R extends SmithingRecipe> void registerExtension(final Class<R> clazz, final Extension<R> ext) {
        ApothSmithingCategory.EXTENSIONS.put(clazz, (Extension<SmithingRecipe>)ext);
    }
    
    static {
        RECIPE_GUI_VANILLA = new ResourceLocation("jei", "textures/gui/gui_vanilla.png");
        EXTENSIONS = new IdentityHashMap<Class<? extends SmithingRecipe>, Extension<SmithingRecipe>>();
    }
    
    public interface Extension<R extends SmithingRecipe> extends IRecipeCategoryExtension
    {
        void setRecipe(final IRecipeLayoutBuilder p0, final R p1, final IFocusGroup p2);
        
        void draw(final R p0, final IRecipeSlotsView p1, final GuiGraphics p2, final double p3, final double p4);
    }
}
